\input Head

\section{\tt UnitTest}
% A short (preferably one-line) description of {\tt UnitTest}.

Facilitates the reporting of component test results for datacondAPI 
classes.

\subsection{Description}
% A longer description of what {\tt UnitTest} is used for.

Each class written for the datacondAPI is accompanied by a test 
program that drives the class to verify that it:
(i) acts correctly given nominal data, 
(ii) throws the appropriate exceptions in exceptional circumstances,
(iii) appropriately catches and handles exceptions it is meant to handle. 
{\tt UnitTest} is a class that facilities the reporting of the 
component test results for datacondAPI classes by providing the 
following methods:
%{\tt UnitTest\/} has methods {\tt Init()\/}, 
%{\tt IsVerbose()}, {\tt Message()\/}, {\tt Check()\/}, and
%{\tt Exit()\/}, which are used to report test results:
%
\begin{description}
\item {\tt Init(int ArgC, char** ArgV)\/} 
should be called
at the beginning of each test program;
it allows the user to specify the amount of detail reported in
the test results. 
If the option {\tt  --verbose\/} is entered at the command line,
information about the results of each test is written to cout;
otherwise, no output is written.
\item {\tt IsVerbose(void)\/} 
returns a boolean indicating if the verbose flag was set, which 
occurs if either the environment variable
{\tt TEST\_VERBOSE\_MODE\/} was defined or {\tt --verbose\/} was 
entered at the command line.
\item {\tt Message(bool)\/} 
allows the user to write diagnostic 
messages to cout.
For example, if {\tt Test\/} is a {\tt UnitTest\/} object,
%
\begin{verbatim}
Test.Message(true) << "Testing Something\n";
\end{verbatim}
%
writes ``{\tt -- MESG: Testing Something\/}" to cout if the verbose
flag is set.
If the boolean argument to {\tt Message()\/} is false, the string 
``{\tt -- MESG:\/}" is not included in the message.
\item {\tt Check()\/} 
takes a boolean or a boolean and a string as arguments. 
The boolean should be true if and only if the test is successfully
passed. 
The {\tt Check(bool)\/} method returns a reference to an ostream, 
which should be the object of a short explanatory message. 
The explanatory string can be included as a second argument to the 
{\tt Check()} method, as in {\tt Check(bool, string)}.
For example, if {\tt Test\/} is a {\tt UnitTest\/} object, 
%
\begin{verbatim}
bool result;
...
Test.Check(result) << "foo allocation test\n";
\end{verbatim} 
%
and 
%
\begin{verbatim}
bool result;
...
Test.Check(result, "foo allocation test");
\end{verbatim} 
%
do the same thing.
Explanatory messages should not state pass or fail: that information
is provided by the boolean condition that is always an argument to
the {\tt Check()} method. 
\item {\tt Exit(void)} 
should be called at the end of each test program; 
it returns 0 if and only if all component tests are successfully passed. 
\end{description}

\subsection{Operating Instructions}

\subsubsection{Example Usage}
% A verbatim block of example code showing proper usage of {\tt
% UnitTest}.

All test files should follow the pattern below:

\begin{verbatim}
#include "unittest.h"

// include other headers

UnitTest Test; // global instantiation of test class

void TestSomething()
{
    Test.Message() << "Testing Something\n"; // optional
    
    // compute something that should be true
    
    Test.Check(something) << "Something\n";
    
    // more tests
    
}

void TestException()
{
    Test.Message() << "Testing Exception\n"; // optional
    
    try
    {
        // do something that should throw an Exception
        
        Test.Check(false) << "Exception (no throw)\n";
    }
    catch(const Exception&)
    {
        Test.Check(true) << "Exception\n";
    }
    catch(...)
    {
        Test.Check(false) << "Exception (wrong throw)\n";
    }
    
    // more tests
}

// more test functions

void ReplacementUnexpectedHandler()
{
    Test.Message() << "Exception specification violation\n";
    throw bad_exception();
}

int main(int argc, char** argv)
{

    Test.Init(argc, argv); // initialize with command line
    Test.Message(false) << "$Id"; // file identifier
    
    std::set_unexpected(ReplacementUnexpectedHandler);
    
    try
    {
        TestSomething();
        TestError();
    
        // more test functions
    }
    catch(...)
    {
        Test.Check(false) << "Unexpected exception\n";
    }
    Test.Exit(); // returns 0 (pass), or 1 (fail) if any Check was false.
}
\end{verbatim}

\subsection{Algorithms}
% A discussion of the algorithms used by {\tt UnitTest}.

Not applicable.

\subsection{Accuracy}
% A discussion of issues related to the accuracy of numerical routines
% used by {\tt UnitTest}---e.g., approximations,  argument ranges, etc.

Not applicable.

\subsection{Performance}
% A discussion of issues related to the speed (e.g., $O(N\log N)$) of
% computationally demanding routines used by {\tt UnitTest}.

Not applicable.

\subsection{Testing}
% A description of any test code/test classes that were used to test
% {\tt UnitTest}. 

Not applicable.

\subsection{Notes}
% Miscellaneous notes about {\tt UnitTest} that do not appear
% elsewhere, things that remain to be done, etc.  

\subsection{See Also}
% A list of derived classes, base classes, etc.\ closely related to
% {\tt UnitTest}. 

%\subsection{References}
% A list of references for any algorithms, etc.\ used by {\tt
% UnitTest}. 

\begin{thebibliography}{99}
\end{thebibliography}

\input Tail

%%% Local Variables: 
%%% mode: latex
%%% TeX-master: "datacondAPI"
%%% End: 

